﻿namespace Model
{
    public class Album 
    {
        public string Name
        {
            get => name;

            set
            {
                if (value != null && value.Length < 75)
                {
                    name = value;
                }
            }
        }

        private string name ="Unknown";

        public string Description
        {
            get => description;

            set
            {
                if (value != null && value.Length < 500)
                {
                    description = value;
                }
            }
        }

        private string description ="";

        private List<Title> titles = new List<Title>();

        public IEnumerable<Title> Titles
        { 
            get
            {
                return titles.ToList();
            }
        }

        public string ImageURL
        {
            get => imageURL;

            set
            {
                if (value != null && value.Contains('.'))
                {
                    imageURL = value;
                }
            }
        }

        private string imageURL = "none.png";

        public Artist Artist { get; set; }

        public string Information
        {
            get => information;

            set
            {
                if (value != null && value.Length < 500)
                {
                    information = value;
                }
            }
        }

        private string information = "";

        public Album(string name, string file_Name, Artist artist, string description, string information)
        {
            Name = name;
            ImageURL = file_Name;
            Artist = artist;
            Description = description;
            Information = information;
        }

        public void AddTitle(Title title)
        {
            titles.Add(title);
        }

        public void RemoveTitle(Title title)
        {
            foreach(var item in titles)
            {
                titles = titles.Where(item => item != title).ToList();
            }
        }

    }
}