﻿namespace Model;

public class Artist
{
    public string Name
    {
        get => name;

        set
        {
            if (value != null && value.Length < 75)
            {
                name = value;
            }
        }
    }

    private string name = "Unknown";

    private List<Album> albums = new List<Album>();

    public IEnumerable<Album> Albums
    { 
        get
        {
            return albums.ToList();
        }
    }

    public Artist(string name)
    {
        Name = name;
    }

    public void AddAlbum(Album album)
    {
        albums.Add(album);
    }
}
