﻿namespace Model.Stub;

public class Manager
{
    public IDataManager DataManager { get; set; }

    private List<Album> albums = new List<Album>();

    public IEnumerable<Album> Albums
    {
        get
        {
            return albums.ToList();
        }
    }

    private List<CustomTitle> customTitles = new List<CustomTitle>();

    public IEnumerable<CustomTitle> CustomTitles
    {
        get
        {
            return customTitles.ToList();
        }
    }

    private List<InfoTitle> infoTitles = new List<InfoTitle>();

    public IEnumerable<InfoTitle> InfoTitles
    {
        get
        {
            return infoTitles.ToList();
        }
    }

    private List<Playlist> playlists = new List<Playlist>();

    public IEnumerable<Playlist> Playlists
    {
        get
        {
            return playlists.ToList();
        }
    }

    private List<Artist> artists = new List<Artist>();

    public IEnumerable<Artist> Artists
    {
        get
        {
            return artists.ToList();
        }
    }

    public Manager()
    {
        DataManager = new StubManager();

        albums = DataManager.GetAlbums();
        customTitles = DataManager.GetCustomTitles();
        infoTitles = DataManager.GetInfoTitles();
        playlists = DataManager.GetPlaylists();
        artists = DataManager.GetArtists();
    }

    public void AddAlbum(Album album)
    {
        DataManager.AddAlbum(album);
        albums = DataManager.GetAlbums();
    }

    public void AddCustomTitle(CustomTitle title)
    {
        DataManager.AddCustomTitle(title);
        customTitles = DataManager.GetCustomTitles();
    }

    public void AddInfoTitle(InfoTitle title)
    {
        DataManager.AddInfoTitle(title);
        infoTitles = DataManager.GetInfoTitles();
    }

    public void AddPlaylist(Playlist playlist)
    {
        DataManager.AddPlaylist(playlist);
        playlists = DataManager.GetPlaylists();
    }

    public void RemoveAlbum(Album album)
    {
        DataManager.RemoveAlbum(album);
        albums = DataManager.GetAlbums();
    }

    public void RemoveCustomTitle(CustomTitle title)
    {
        DataManager.RemoveCustomTitle(title);
        customTitles = DataManager.GetCustomTitles();
    }

    public void RemoveInfoTitle(InfoTitle title)
    {
        DataManager.RemoveInfoTitle(title);
        infoTitles = DataManager.GetInfoTitles();
    }

    public void RemovePlaylist(Playlist playlist)
    {
        DataManager.RemovePlaylist(playlist);
        playlists = DataManager.GetPlaylists();
    }

    public IEnumerable<Album> GetAlbums()
    {
        return DataManager.GetAlbums();
    }

    public IEnumerable<CustomTitle> GetCustomTitles()
    {
        return DataManager.GetCustomTitles();
    }

    public IEnumerable<InfoTitle> GetInfoTitles()
    {
        return DataManager.GetInfoTitles();
    }

    public IEnumerable<Artist> GetArtists()
    {
        return DataManager.GetArtists();
    }

}
