﻿namespace Model.Stub;

public class StubManager : IDataManager
{

    private List<Artist> artists;

    public IEnumerable<Artist> Artists
    {
        get
        {
            return artists.ToList();
        }
    }

    private List<Album> albums;

    public IEnumerable<Album> Albums
    {
        get
        {
            return albums.ToList();
        }
    }

    private List<Playlist> playlists;

    public IEnumerable<Playlist> Playlists
    {
        get
        {
            return playlists.ToList();
        }
    }

    private List<InfoTitle> infoTitles;

    public IEnumerable<InfoTitle> InfoTitles
    {
        get
        {
            return infoTitles.ToList();
        }
    }

    private List<CustomTitle> customTitles;

    public IEnumerable<CustomTitle> CustomTitles
    {
        get
        {
            return customTitles.ToList();
        }
    }

    public StubManager()
    {
        StubAlbum stubAlbum = new StubAlbum();
        albums = stubAlbum.GetAlbums();

        StubPlaylist stubPlaylist = new StubPlaylist();
        playlists = stubPlaylist.GetPlaylists();

        StubArtist stubArtist = new StubArtist();
        artists = stubArtist.GetArtists();

        StubInfoTitle stubInfoTitle = new StubInfoTitle();
        infoTitles = stubInfoTitle.GetInfoTitles();

        StubCustomTitle stubCustomTitle = new StubCustomTitle();
        customTitles = stubCustomTitle.GetCustomTitles();

        Artist? Artist1 = Artists.FirstOrDefault(a => a.Name == "Critien");
        Artist? Artist2 = Artists.FirstOrDefault(a => a.Name == "Gouriet");
        Artist? Artist3 = Artists.FirstOrDefault(a => a.Name == "Poulifer");
        Artist? Artist4 = Artists.FirstOrDefault(a => a.Name == "Credian");

        Album? Album1 = Albums.FirstOrDefault(a => a.Name == "la street");
        Album? Album2 = Albums.FirstOrDefault(a => a.Name == "la jsp");
        Album? Album3 = Albums.FirstOrDefault(a => a.Name == "la pas le temps");
        Album? Album4 = Albums.FirstOrDefault(a => a.Name == "la pas le choix");

        Playlist? Playlist1 = Playlists.FirstOrDefault(a => a.Name == "Playlist1");
        Playlist? Playlist2 = Playlists.FirstOrDefault(a => a.Name == "Playlist2");

        CustomTitle? CustomTitle1 = CustomTitles.FirstOrDefault(a => a.Name == "MaMusique");
        CustomTitle? CustomTitle2 = CustomTitles.FirstOrDefault(a => a.Name == "MusiqueGeniale");
        CustomTitle? CustomTitle3 = CustomTitles.FirstOrDefault(a => a.Name == "custom3");

        InfoTitle? InfoTitle1 = InfoTitles.FirstOrDefault(a => a.Name == "info1");
        InfoTitle? InfoTitle2 = InfoTitles.FirstOrDefault(a => a.Name == "info2");

        if (Artist1 != null)
        {
            if (Album1 != null) {
                Artist1.AddAlbum(Album1);
            }
            if(Album2 != null)
            {
                Artist1.AddAlbum(Album2);
            }
        }
        if (Artist2 != null)
        {
            if(Album3 != null)
            {
                Artist2.AddAlbum(Album3);
            }
            if(Album4 != null)
            {
                Artist2.AddAlbum(Album4);
            }
        }

        if (Playlist1 != null)
        {
            if (CustomTitle1 != null)
            {
                Playlist1.AddTitle(CustomTitle1);
            }
            if (CustomTitle2 != null)
            {
                Playlist1.AddTitle(CustomTitle2);
            }
        }
        if (Playlist2 != null)
        {
            if(CustomTitle2 != null)
            {
                Playlist2.AddTitle(CustomTitle2);
            }
            if(CustomTitle3 != null)
            {
                Playlist2.AddTitle(CustomTitle3);
            }
        }

        if (Album1 != null)
        {
            if(InfoTitle1 != null)
            {
                Album1.AddTitle(InfoTitle1);
            }
            if(InfoTitle2 != null)
            {
                Album1.AddTitle(InfoTitle2);
            }
        }
        if (Album2 != null && InfoTitle2 != null)
        {
            Album2.AddTitle(InfoTitle2);
        }

    }

    public List<Album> GetAlbums()
    {
        return albums;
    }

    public List<Artist> GetArtists()
    {
        return artists;
    }

    public List<Playlist> GetPlaylists()
    {
        return playlists;
    }

    public List<CustomTitle> GetCustomTitles()
    {
        return customTitles;
    }

    public List<InfoTitle> GetInfoTitles()
    {
        return infoTitles;
    }

    public void AddAlbum(Album album)
    {
        albums.Add(album);
    }

    public void AddCustomTitle(CustomTitle title)
    {
        customTitles.Add(title);
    }

    public void AddInfoTitle(InfoTitle title)
    {
        infoTitles.Add(title);
    }

    public void AddPlaylist(Playlist playlist)
    {
        playlists.Add(playlist);
    }

    public void AddArtist(Artist artist)
    {
        artists.Add(artist);
    }



    public void RemoveAlbum(Album album)
    {
        albums.Remove(album);
    }

    public void RemoveCustomTitle(CustomTitle title)
    {
        customTitles.Remove(title);
    }

    public void RemoveInfoTitle(InfoTitle title)
    {
        infoTitles.Remove(title);
    }

    public void RemovePlaylist(Playlist playlist)
    {
        playlists.Remove(playlist);
    }

    public void RemoveArtist(Artist artist)
    {
        artists.Remove(artist);
    }
}
